

PImage img;
PImage img1;
PImage img2;
PImage skiGuy;
PImage obstacleImage[] = new PImage[4];

int sunpos1= 120;
int sunpos2= 120;
int sunsize =120;

boolean startPage = true, instructionPage = false, gamePage = false, gameOver = false;

int [] neigeX= new int[50];
int [] neigeY= new int[50];

int [][] obstacle = new int[5][4]; 

float dotX, dotY; // coordinates of the dot
float bgY = 1200; // Y coordinate of the background
int dotSize = 150; // size of the player
int playerspeed = 10;
int treeSize = 170;
int animalSize = 150;
int goatSpeed = 5;
int iceBergSize = 300;
int bgSpeed = 5; // speed of the background
int formSize = 30; // size of the forms
boolean collided = false; // flag for collision detection
int score = 0; // score

int numberOfObstacleOnScreen = 0;


void setup() 
{
size (1000,1000);
img = loadImage("Ressources/cabine skieur.png");
img1 = loadImage("Ressources/thumbnail_Image.png");
img2 = loadImage("Ressources/Imageover.png"); // Game over image
img2.resize(1200, 1200);
skiGuy = loadImage("Ressources/Skier.png");
skiGuy.resize(dotSize, dotSize);
obstacleImage[0] = loadImage("Ressources/Coca Tree.png");
obstacleImage[0].resize(treeSize, treeSize);
obstacleImage[1] = loadImage("Ressources/IceBerg.png");
obstacleImage[1].resize(iceBergSize, iceBergSize);
obstacleImage[2] = loadImage("Ressources/SteinBock.png");
obstacleImage[2].resize(animalSize, animalSize);
obstacleImage[3] = loadImage("Ressources/Paradise Tree.png");
obstacleImage[3].resize(treeSize, treeSize);
dotX = width / 2;
dotY = dotSize + 20;
}

void draw() {
  
  if(startPage)
  {
    StartScreen();
  }
  else if (instructionPage)
  {
    InstructionScreen();;
    
  }
  else if (gamePage)
  {
    GameScreen();
  }
  else if (gameOver)
  {
    GameOverScreen();
  }

  
  



}

void keyPressed() {
  if(startPage)
  {
    startPage = false;
    instructionPage = true;
    
  }
  else if(instructionPage)
  {
    instructionPage = false;
    gamePage = true;
  }
  else if(gameOver)
  {
    gameOver = false;
    gamePage = true;
  }
}

void GameScreen()
{
  background(255);

  // update background
  bgY -= bgSpeed;
  if (bgY <= 0) {
    bgY = height;
  }
  fill(200, 200, 255);
  rect(0, bgY, width, 50);

  // draw dot
  fill(255, 0, 0);
  image(skiGuy, dotX, dotY);

  // move dot
  if (keyPressed) {
    if (keyCode == LEFT && dotX > 0) {
      dotX -= playerspeed;
    } else if (keyCode == RIGHT && dotX < width - dotSize) {
      dotX += playerspeed;
    }
  }

  // spawn obstacle

  for(int i = 0; i < 5; i++)
  {
    // check if the obstacle exists
    if (obstacle[i][1] == 0)
    {

      if (random(1000) < 700)
      {
        // we create the obstacle

      // Choose a random image
      obstacle[i][0] = (int)random(3);
      // Choose a random X
      obstacle[i][2] = (int)random(width);
      // set the initial Y
      obstacle[i][3] = height - (int)random(300);
      // we activate it
      obstacle[i][1] = 1;

      }
      


    }
    else
    {
      // we just update it´s y position
      obstacle[i][3] -= bgSpeed;
      // if it´s a Goat it walks
      if (obstacle[i][0] == 2)
      {
        if (obstacle[i][2] < width){
          obstacle[i][2] += goatSpeed;
        }
        else
        {
          obstacle[i][1] = 0;

        }
        
      }

    }
    //check if the obstacle run out for the screen
    if (obstacle[i][3] <= 0)
    {
      // if it is we put it as unactif
      obstacle[i][1] = 0;

    }

    //fill(0, 255, 0);
    image(obstacleImage[obstacle[i][0]], obstacle[i][2], obstacle[i][3]);
  
    
   

    // check collision
    if (dist(dotX, dotY, obstacle[i][2] + formSize/2, obstacle[i][3] + formSize/2) < dotSize/2 + formSize/2) {
      collided = true;
    }

  }
  

  // update score
  if (collided) {
    for(int i = 0; i < 5; i++)
    {
      obstacle[i][0] = 0;
      obstacle[i][1] = 0;
      obstacle[i][2] = 0;
      obstacle[i][3] = 0;

    }
    collided = false;
    gamePage = false;
    gameOver = true;
    collided = false;
    

  } else {
    score++;
    textSize(24);
    fill(0);
    textAlign(LEFT);
    text("SCORE: " + score, 10, 30);
  }
}



void GameOverScreen()
{
  background (0,200,255);
imageMode(CENTER);       // image position

for(int i=0;i<neigeX.length;i++)
{
neigeX[i]=int(random(0,1000));   // Schnee
neigeY[i]=int(random(0,1000));


noStroke();
fill(255,255,255);
circle(neigeX[i],neigeY[i],10);   //Sonne


stroke(255,204,0);
strokeWeight(4);
fill(255,204,0);
circle( 120,120,80);
}


line( sunpos1 +80 , 80, sunpos2+180,50);  //Bergen
line( sunpos1 -80 , 80, sunpos2-180,50);
line( sunpos1 +80 , 160, sunpos2+180,200);
line( sunpos1 -80 , 160, sunpos2-180,200);
line( sunpos1  , 50, sunpos2,1);
line( sunpos1 ,300 , sunpos2,200);


stroke(255,255,255);
strokeWeight(4);
fill(255,255,255);


triangle(1, 1000, 232, 400, 344, 1000);
triangle(1, 1000, 522, 80, 1000, 1000);
triangle(300, 1000, 800, 120, 980, 1000);
triangle(120, 1000, 950, 400, 1000, 1000);

image(img2,550,600);  // Game over image



 
 
}


void InstructionScreen()
{

background (0,200,255);


for(int i=0;i<neigeX.length;i++)
{
neigeX[i]=int(random(0,1000)); // schnee
neigeY[i]=int(random(0,1000));


noStroke();
fill(255,255,255);
circle(neigeX[i],neigeY[i],10);
}

stroke(255,204,0);
strokeWeight(4);   // Sonne
fill(255,204,0);
circle( 120,120,80);


line( sunpos1 +80 , 80, sunpos2+180,50);  // Bergen
line( sunpos1 -80 , 80, sunpos2-180,50);
line( sunpos1 +80 , 160, sunpos2+180,200);
line( sunpos1 -80 , 160, sunpos2-180,200);
line( sunpos1  , 50, sunpos2,1);
line( sunpos1 ,300 , sunpos2,200);


stroke(255,255,255);
strokeWeight(4);
fill(255,255,255);

triangle(1, 1000, 232, 400, 344, 1000);
triangle(1, 1000, 522, 80, 1000, 1000);
triangle(300, 1000, 800, 120, 980, 1000);
triangle(120, 1000, 950, 400, 1000, 1000);


image(img1, 0, 0); // Skifahrer

textSize(40);
String s = "Er muss den Hindernissen mit den Pfeiltasten der Tastatur ausweichen. Wenn er es nicht schafft, einem Hindernis auszuweichen, wird er verletzt und das Spiel ist vorbei.";
fill(255,0,0);
text(s, 100, 600, 800, 800);  // Text in der text box
}


void StartScreen()
{

  background (0,200,255);

for(int i=0;i<neigeX.length;i++)
{
neigeX[i]=int(random(0,1000));
neigeY[i]=int(random(0,1000));


noStroke();
fill(255,255,255);
circle(neigeX[i],neigeY[i],10);
}







stroke(255,204,0);
strokeWeight(4);
fill(255,204,0);
circle( 120,120,80);


line( sunpos1 +80 , 80, sunpos2+180,50);
line( sunpos1 -80 , 80, sunpos2-180,50);
line( sunpos1 +80 , 160, sunpos2+180,200);
line( sunpos1 -80 , 160, sunpos2-180,200);
line( sunpos1  , 50, sunpos2,1);
line( sunpos1 ,300 , sunpos2,200);


stroke(255,255,255);
strokeWeight(4);
fill(255,255,255);

triangle(1, 1000, 232, 400, 344, 1000);
triangle(1, 1000, 522, 80, 1000, 1000);
triangle(300, 1000, 800, 120, 980, 1000);
triangle(120, 1000, 950, 400, 1000, 1000);

stroke(0,0,0);
strokeWeight(10);
line (1,1,1000,300);
image(img, 0, 0);

 textSize(128);
 fill(255, 0, 0);
text("start", 320, 750);
}
